# -*- coding: utf-8 -*-
"""
Created on Wed Nov 11 13:56:10 2020

Rectangle
                   |
             p1.---|-----------.
               |   |           |
               .---|-----------.p2
        -----------+------------
                   |


@author: Studente
"""

class Point:
    def __init__(self, x, y):
        #if (type(x) == int or type(x) == float) and (type(y)  == int or type(y) == float):
        if isinstance(x, (int, float)) and isinstance(y, (int, float)):
            self.x = x
            self.y = y
        elif isinstance(x, str) and isinstance(y, str):
            self.x = float(x)
            self.y = float(y)
        else:
            raise TypeError ('points require x and y to be int or float')
        
        
    def __str__(self):
        #return 'p({},{})'.format(self.x, self.y)
        return f'p({self.x},{self.y})'

    
    def __repr__(self):
        return f'point at ({self.x},{self.y})'
    
    
    def distance_from(self, p):
        if not isinstance(p , Point):
#        if type(p) == Point
            raise TypeError ('distance_form takes another point')
        return ((self.x - p.x)**2 + (self.y - p.y)**2)**0.5

class Rectangle:
    def __init__(self, p1, p2):
        if not isinstance(p1, Point) or not isinstance(p2, Point):
            raise TypeError ('rectangles require two Points')
        if p1.x == p2.x or p1.y == p2.y:
            raise ValueError ('rectangles have to be surface > 0')
        pass
        
        
    def surface(self):
        ''' Returns the surface of the rectangle '''
        pass
   
    
    def perimeter(self):
        ''' Returns the perimeter of the rectangle '''
        pass
    
    
    def diag(self):
        ''' Returns the diagonal (distance between p1 and p2?) '''
        pass
    